// Value list class -*- c++ -*-

#ifdef __GNUC__
# pragma implementation
#endif // __GNUC__
#include "ValueList.h"
#include "Value.h"

#include <cstring>

#if defined __SUNPRO_CC
using std::memset;
#endif // __SUNPRO_CC

/** @file ValueList.C
 * List of values (components of StructValue, BufferValue or VectorValue)
 */

ValueList::ValueList (card_t size) :
  mySize (size), myComponents (NULL)
{
  if (mySize) {
    myComponents = new class Value*[mySize];
    memset (myComponents, 0, mySize * sizeof *myComponents);
  }
}

ValueList::ValueList (const class ValueList& old) :
  mySize (old.mySize), myComponents (NULL)
{
  if (mySize) {
    myComponents = new class Value*[mySize];
    for (card_t i = 0; i < mySize; i++)
      myComponents[i] =
	old.myComponents[i] ? old.myComponents[i]->copy () : NULL;
  }
}

ValueList::~ValueList ()
{
  for (card_t i = 0; i < mySize; i++)
    delete myComponents[i];

  delete[] myComponents;
}
